(function() {
	"use strict";

	angular
		.module("app.divestiture.smo")
		.directive("smoRaidLog", smoRaidLog);

	function smoRaidLog() {
		var directive = {
			restrict: "E",
			scope: {
				functionId: "=",
				resolve: "="
			},
			controller: smoRaidLogController,
			controllerAs: "vm",
			bindToController: true,
			templateUrl: "HeatmapComponent/heamap.html"
		};

		return directive;
	}

	smoRaidLogController.$inject = ["$scope", "$filter", "$state", "$stateParams"];

	function smoRaidLogController($scope, $state, $filter, $stateParams) {
    var vm = this;

    vm.showBackButton = $stateParams.showBackButton || false;
		vm.tabDataArray = [{
			tabLabel: "Risks",
			formConfigKey: "RISKS",
			listTitle: "Risks And Issues",
			listView: "Risks",
			templateColumns: { "ItemOwner": "contactsColumn", "ItemStatus": "statusColumn", "Function": "functionsColumn" },
			defaultValues: {"IssueRiskCategory": "Risk"}
		},
		{
			tabLabel: "Actions",
			formConfigKey: "ACTIONS",
			listTitle: "Actions",
			listView: "Datasheet",
			templateColumns: { "ItemOwner": "contactsColumn", "ItemStatus": "statusColumn", "Function": "functionsColumn" }
		},
		{
			tabLabel: "Issues",
			formConfigKey: "ISSUES",
			listTitle: "Risks And Issues",
			listView: "Issues",
			templateColumns: { "ItemOwner": "contactsColumn", "ItemStatus": "statusColumn", "Function": "functionsColumn" },
			defaultValues: {"IssueRiskCategory": "Issue"}
		},
		{
			tabLabel: "Decisions",
			formConfigKey: "DECISIONS",
			listTitle: "Decisions",
			listView: "Datasheet",
			templateColumns: { "ItemOwner": "contactsColumn", "ItemStatus": "statusColumn", "Function": "functionsColumn" }
		}];
		vm.setActiveTabIndex = setActiveTabIndex;

		function findIndexByTabName(tabName) {
			var currentActiveTabIndex = _.findIndex(vm.tabDataArray, function(tab) {
				return tabName === tab.tabLabel;
			});
			if (!currentActiveTabIndex || currentActiveTabIndex === -1) {
				currentActiveTabIndex = 0;
			}
			return currentActiveTabIndex;
		}

		function setActiveTabIndex(index) {
			vm.activeTabIndex = index;
			updateURL(vm.activeTabIndex);
		}

		activate();

		function activate() {
			vm.activeTabIndex = findIndexByTabName($stateParams.activeTab);
			updateURL(vm.activeTabIndex);
		}

		function updateURL(index) {
			var activeTab = vm.tabDataArray[index].tabLabel;
			$state.go(".", {activeTab: activeTab}, {notify: false});
		}
  }
})();